#include <stdio.h>
#include "gfx.h"

char *evtypestr(int typ)
{
  switch(typ)
  {
case GFXEV_BUTTON_PRESS: return   "B.DOWN"; 
case GFXEV_BUTTON_RELEASE: return "B.UP  "; 
case GFXEV_KEY_PRESS: return      "K.DOWN";
case GFXEV_KEY_RELEASE: return    "K.UP  ";
case GFXEV_POINTER_MOVE: return   "MOVE  ";
case GFXEV_QUIT: return           "QUIT  ";
  }
  return "UNKNOW";
}



int main()
{
  gfx_event_t event;
  if (gfx_init(NULL,640,480,"This is nice"))
    return 1;
  while(1)
  {
    if (gfx_event(NULL, &event))
    {
       switch(event.type)
       {
       case GFXEV_KEY_PRESS:
         printf("KEY_PRESS ");
         if (event.key==GFX_K_PRT)
         {
            printf("(%s) [%x]\n", event.string,event.wide); 
            continue;
         }
         if (event.key&GFX_K_CONTROL) printf("Ctrl+");
         if (event.key&GFX_K_SHIFT) printf("Shift+");
         event.key&= ~(GFX_K_CONTROL | GFX_K_SHIFT);
         switch(event.key)
         {
case GFX_K_BACKSPACE: printf("BACKSPACE"); break;
case GFX_K_TAB:   printf("TAB"); break;
case GFX_K_RETURN:   printf("RETURN"); break;
case GFX_K_ESCAPE:   printf("ESCAPE"); break;
case GFX_K_INSERT:   printf("INSERT"); break;
case GFX_K_DELETE:   printf("DELETE"); break;
case GFX_K_HOME:   printf("HOME"); break;
case GFX_K_END:   printf("END"); break;
case GFX_K_PAGEUP:   printf("PAGEUP"); break;
case GFX_K_PAGEDOWN :   printf("PAGEDOWN"); break;
case GFX_K_LEFT :   printf("LEFT"); break;
case GFX_K_RIGHT :   printf("RIGHT"); break;
case GFX_K_DOWN :   printf("DOWN"); break;
case GFX_K_UP:    printf("UP"); break;
default:
          if (event.key>=0x20 && event.key<='~') printf("%c",event.key);
          else printf("??");
         }
         printf("\n");
         continue;
       }
       printf("[%s] (%d,%d) M%x B(%d) K(%d) \n", evtypestr(event.type),
                            event.x, event.y, event.modifiers,
                            event.button, event.key);
       if (event.type==GFXEV_QUIT) break;
    }
  }
  gfx_close();
  return 0;
}


