#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include "gfx.h"

static int  fdia_pad = 5,
            fdia_label_pad= 2,
            fdia_but_pad= 2,
            fdia_extpad= 10;

static int imax2(int a,int b) { return a>b?a:b; }

typedef struct
{
  int type; // 'F' or 'D'
  char *name;
} flnode_t;

static flnode_t* get_file_list(char *dirname,size_t *Rn)
{
  DIR *dir;
  struct dirent *de;
  buffer_t *buffer;
  flnode_t node;
  size_t size;

  dir= opendir(dirname);
  if (!dir) return NULL;
  buffer= buffer_new(sizeof(flnode_t)*20);
  while((de=readdir(dir)))
  {
    buffer_write(B, &node, sizeof(node));
  }
  buffer_free(B, &ret, &size);
  *Rn= size/sizeof(node);
  return ret;
}


static int create_fsel_screen
  (char *title, char *ok, char *cancel, void *filter,
   int *RWlabel, int *RWlist, int *RWtext)
{
  int scr;

  // widgets..
  int Wlabel,Wlist,Wdrop,Wok,Wcancel,Wtext;
  // combined widget coordinates
  int Cw, Ch, Cx, Cy;
  int xww, xwh;
  gfx_geometry(&xww,&xwh);
  Cw= xww - 2*fdia_extpad;
  Ch= xwh - 2*fdia_extpad;
  Cx= fdia_extpad;
  Cy= fdia_extpad;

  int label_x, label_y, label_w, label_h;
  int list_x, list_y, list_w, list_h;
  int drop_x, drop_y, drop_w, drop_h;
  int ok_x, ok_y, ok_w, ok_h;
  int cancel_x, cancel_y, cancel_w, cancel_h;
  int text_x, text_y, text_w, text_h;
  int fh1, fh2;
  int tw_ok, tw_cancel;

  ok= ok ? ok : "OK";
  cancel= cancel ? cancel : "Cancel";

  gfx_text_size(1, ok, &tw_ok, &fh1);
  gfx_text_size(1, cancel, &tw_cancel, NULL);
  gfx_text_size(2, "M", NULL, &fh2);

  label_x= Cx + fdia_pad;
  label_y= Cy + fdia_pad;
  label_w= Cw-2*fdia_pad;
  label_h= fh2+ 2*fdia_label_pad;

  text_x= label_x;
  text_y= label_y + label_h + fdia_pad;
  text_w= label_w;
  text_h= label_h;

  list_x= label_x;
  list_y= text_y + text_h + fdia_pad;
  list_w= label_w;

  cancel_w= imax2(tw_cancel,tw_ok) + 2*fdia_but_pad;
  ok_w= cancel_w;
  cancel_h= label_h;
  ok_h= cancel_h;

  cancel_x= Cx+Cw - fdia_pad - cancel_w;
  ok_x= cancel_x - fdia_pad - ok_w;

  cancel_y= Cy+Ch - fdia_pad - cancel_h;
  ok_y= cancel_y;

  list_h= cancel_y - list_y - fdia_pad;

  drop_x= label_x;
  drop_y= cancel_y;
  drop_w= ok_x - drop_x - fdia_pad;
  drop_h= cancel_h;

  scr= gfx_push_screen();

  gfx_fill_rect(0,Cx,Cy,Cw,Ch,0xededed);
  gfx_draw_rect(0, Cx-1, Cy-1, Cw+2, Ch+2, 0x00);
  gfx_draw_rect(0, Cx-2, Cy-2, Cw+4, Ch+4, 0x00);

  Wlabel= gfx_label(0,2, 0x00, 0xededed, label_x, label_y, label_w, label_h,
                    title);

  Wtext= gfx_text_entry(0, text_x, text_y, text_w, text_h, "");
  Wlist= gfx_list(0, list_x, list_y, list_w, list_h, 0, NULL, GFXEV_LAST+1);
  Wok= gfx_button(0, ok_x, ok_y, ok_w, ok_h, ok, GFXEV_LAST+2);
  Wcancel= gfx_button(0, cancel_x, cancel_y, cancel_w, cancel_h, 
                                            cancel, GFXEV_LAST+3);
  Wdrop= gfx_dropdown(drop_x, drop_y, drop_w, drop_h, GFXEV_LAST+4);
  gfx_dropdown_show(Wdrop,1);

  gfx_update(0,0,xww, xwh);

  *RWlabel= Wlabel;
  *RWtext= Wtext;
  *RWlist= Wlist;

  return scr;
}

int gfx_select_file(int func, char *title, char *ok, char *cancel,
                    char *init_file, char **Rfile, void *filter)
{
  int Wlabel,Wlist,Wtext;
  int scr;
  gfx_event_t event;

  title= title ? title : "Select File";
  scr= create_fsel_screen(title, ok, cancel, filter, &Wlabel,&Wlist, &Wtext);
  while(1)
  {
    if (!gfx_event(NULL,&event)) continue;
    if (event.type==GFXEV_POINTER_MOVE) continue;
    printf("event: %d\n", event.type);
  }
}



int main()
{
  int R;
  char *self;
  self= "N/A";
  gfx_init(NULL,640,480,"Test");
  R= gfx_select_file('R', "Open file", "Open", "Cancel", "/home/dodo/pof.txt",
                   &self, NULL);
  printf("%d [%s]\n", R, self);
  return 0;
}
