
/***********************************************************************
 *                                                                     *
 *                             Widget Demo                             *
 *                                                                     *
 ***********************************************************************
   Demonstration of various widgets.
 ***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include "gfx.h"
#include "../png/pngio.h"

#define SCR_W     800
#define SCR_H     600
#define BUT_W_BIG 120
#define BUT_W_SMA 80
#define BUT_H     30
#define PAD       10
#define SCR_BG    0xededed

  // actions
enum { 
  AC_BACK= GFXEV_LAST+1, 
  AC_DEMO_MENU,
    AC_MENU1,
    AC_MENU2,
  AC_DEMO_SCROLL,
    AC_SCROLL_HORZ,
    AC_SCROLL_VERT,
  AC_DEMO_LIST,
    AC_LIST1,
    AC_LIST_DELETE,
    AC_LIST_INSERT,
    AC_LIST_CLEAR,
  AC_DEMO_DROPDOWN,
    AC_DROPDOWN_1,
  AC_DEMO_RADIO,
    AC_RADIO1,
    AC_RADIO2,
    AC_RADIO3,
    AC_RADIO4,
  AC_DEMO_CHECKBOX,
    AC_CHECK1,
    AC_CHECK2,
    AC_CHECK3,
    AC_CHECK4,
  AC_DEMO_FILESEL,
    AC_FILESEL_GO,
  AC_DEMO_TOGBUT,
    AC_TOGBUT_1,
    AC_TOGBUT_2,
    AC_TOGBUT_SET1,
    AC_TOGBUT_SET2,
  AC_DEMO_CONFIRM,
    AC_CONFIRM_1,
    AC_CONFIRM_2,
};

static int but_x=PAD, but_y=PAD;
static int last_msg= SCR_H;

static void button(int size, char *text, int action)
{
  int w;
  if (size) w= BUT_W_BIG; else w= BUT_W_SMA;
  if (but_x+w+PAD>SCR_W)
  {
    but_x= PAD;
    but_y+= PAD + BUT_H;
  }
  gfx_button(GFX_UPDATE, but_x, but_y, w, BUT_H, text,action);

  but_x += PAD + w;
}

static int back_button(int w)
{
  button(w, "<Back", AC_BACK);
}

static int message_area(char *title)
{
  int L;
  int w,h;
  int x,y;
  w= SCR_W - PAD - PAD;
  h= BUT_H;
  x= PAD;
  y= last_msg - PAD- h;

  if (title)
  {
    int tw, th;
    gfx_text_size(1, title, &tw,&th);
    gfx_label(GFX_UPDATE,1, 0, SCR_BG, x, y, tw, BUT_H, title);
    x+= tw+ PAD;
    w-= tw+ PAD;
  }

  last_msg= y;
  return gfx_label(GFX_UPDATE,1, 0xffffff, 0x888888, x,y,w,h,"");
}

static void meprintf(int tgt, const char *fmt, ...)
{
  static char buf[10000];
  va_list ap;
  memset(buf,0,sizeof(buf));
  va_start(ap,fmt);
  vsnprintf(buf,sizeof(buf),fmt,ap);
  va_end(ap);
  buf[sizeof(buf)-1]= 0;
  gfx_label_set_text(GFX_UPDATE,tgt,buf);
}

char *poem[]= {
"ALA GEYİK",
"Çocuktum, ufacıktım,",
"Top oynadım,acıktım.",

"Buldum yerde bir erik,",
"Kaptı bir Ala Geyik.",

"Geyik kaçtı ormana,",
"Bindim bir ak doğana.",

"Doğan, yolu şaşırdı,",
"Kaf Dağından aşırdı.",

"Attı beni bir göle;",
"Gölden çıktım bir çöle,",

"Çölde buldum izini,",
"Koştum, tuttum dizini.",

"Geyik beni görünce,",
"Düştü büyük sevince.",

"Verdi bana bir elma,",
"Dedi, dinlenme, durma.",

"Dağdan yürü, kırdan git,",
"Altın Köşke çabuk yet.",

"Seni bekler ezeli,",
"Orda dünya güzeli.",

"Bin yıllık çile doldu!",
"Bunu dedi, kayboldu.",

"Yedim sırlı elmayı,",
"Gördüm gizli dünyayı.",

"Gündüz oldu, geceler;",
"Ak sakallı cüceler,",

"Korkunç devler hortladı,",
"Cinler, cirit oynadı.",

"Kesik başlar yürürdü,",
"Saçlarını sürürdü.",

"Bir de baktım, melekler,",
"Başlarında çiçekler.",

"Devlere el bağlıyor,",
"Gizli gizli ağlıyor.",

"Kılıcımı çıkardım,",
"Perileri kurtardım.",

"Kurtardığım periler,",
"Adım adım geriler,",

"Kanadını açardı,",
"Selam verir, kaçardı.",

"Az, uz gittim, dolaştım,",
"Altın Köşke ulaştım.",

"Bir kapısı açıktı,",
"Öteki kapanıktı.",

"Kapalıyı açarak,",
"Açığa vurdum kapak.",

"At önünde et vardı,",
"İt, ot yemez ağlardı;",

"Otu ata yedirdim,",
"Eti ite yedirdim.",

"Açtım bir elmas oda;",
"Dev şahı uykuda",

"Gördüm, kestim başını,",
"Dedim, Ey dev nerede?",

"Nerede Dünya Güzeli?",
"Dedi, Elinde eli!",

"Döndüm, baktım. Bir Kırgız",
"Elbiseli güzel kız.",

"Durmuş, bakar yanımda,",
"Şimşek çaktı canımda.",

"Güldü, dedi, Türk Beyi!",
"Tanıdın mı geyiği?",

"Kimse, beni bu devden",
"Alamazdı. Ancak sen,",

"Kaya deldin, dağ yardın,",
"Geldin, beni kurtardın.",

"Ah o imiş anladım,",
"Sevincimden ağladım,",

"Dedim, Turan Meleği!",
"Türkün yüce dileği!",

"Yüz milyon Türk bu anda",
"Seni bekler Turanda.",

"Haydi, çabuk varalım,",
"Karanlığı yaralım;",

"Sönük ocak canlansın,",
"Yoksul ülke şanlansın",

"İndik, iti okşadık,",
"At sırtına atladık.",

"Geçtik nice dağ, kaya,",
"Geldik Demirkapıya.",

"Kapanması, çok yıldı,",
"Açıl! dedim, açıldı.",

"Yol verince gizli yurt,",
"Aldı bizi Bozkurt,",

"Kaf Dağından geçirdi,",
"Türk Eline getirdi.",
NULL
};

static int demo_menus()
{
  int x,y;
  gfx_event_t event;

  static TUPiis_t menu1[]= {
  { 1, 0, "One" },
  { 4, 1, "Two" },
  { 9, 1, "Third and the longest one in the sequence, this is quite ridiculous. Most of this shouldn't be shown, but clipped. There is also no way to scroll sideways." },
  { 16, 0, "Four" },
  { 25, 1, "Five" },
};
  static TUPiis_t menu2[500];
  int NENT1,NENT2;
  int L;
  int i;

  NENT1= (sizeof(menu1)/sizeof(menu1[0]));

  for(i=0;poem[i];i++)
  {
   menu2[i].sv= poem[i];
   menu2[i].iv1= i;
   menu2[i].iv2= 0;
  }
  NENT2= i;

  back_button(1);
  button(1,"Show Menu 1", AC_MENU1);
  button(1,"Show Menu 2", AC_MENU2);

  L= message_area(NULL);

  int R;

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_MENU1:
       meprintf(L,"Menu Result= %d", gfx_fwmenu(1, NENT1, menu1)); 
       break;
     case AC_MENU2:
       R= gfx_fwmenu(1,NENT2, menu2);
       meprintf(L,"Menu Result= %d %s", R, R!=-1? menu2[R].sv : "(none)"); 
       break;
     case AC_BACK: return 0;
     }
}

static int demo_scrollbar()
{
  gfx_event_t event;
  double T,B;
  int V,H;
  int S1,S2;

  T= 0.1; B=0.3;
  back_button(1);
  
  S1= gfx_scrollbar(GFX_UPDATE|GFX_VERTICAL, 300,50,15, 250,  T, B, 0.1,
                AC_SCROLL_VERT);
  S2= gfx_scrollbar(GFX_UPDATE|GFX_HORIZONTAL, 50, 300, 250, 15, 0.2, 0.6, 0.08,
               AC_SCROLL_HORZ);
  V= message_area("Vertical:  ");
  H= message_area("Horizontal:");

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_SCROLL_VERT:
           meprintf(V,"%f %f", event.flo0, event.flo1); break;
       break;
     case AC_SCROLL_HORZ:
           meprintf(H,"%f %f", event.flo0, event.flo1); break;
     }
}


static int demo_list()
{

static struct { char *str; int iv; } list1[]=
{
  { "Hello", 0 },
  { "World", 0 },
  { "This is a nice", 0 },
  { "Test for a list", 0 },
  { "How", 0 },
  { "Does", 0 },
  { "It Work?", 0 },
  { "Let me see..", 0 },
  { "In order to", 0 },
  { "Cause an overflow", 0 },
  { "I need to enter", 0 },
  { "More items", 0 },
  { "This way", 0 },
  { "Whether the clipping", 0 },
  { "And the scrolling", 0 },
  { "Works or not", 0 },
  { "I'm also curious about", 0 },
  { "Whether the icons work or not", 0 },
  { "But that's for another time", 0 },
  { NULL, 0 }
};

#define NENT1  (sizeof(list1)/sizeof(list1[0]))

  gfx_event_t event;
  int L;
  int i;
  unsigned int *icon_data[5];
  unsigned int icon_width[5], icon_height[5];

  
  icon_data[0]= NULL; icon_width[0]= icon_height[0]= 0;
  for(i=1;i<5;i++)
  {
    char buf[200];
    sprintf(buf,"image%d.png",i);
    read_png_image(buf,&icon_width[i], &icon_height[i], &icon_data[i]);
  }

  int j;
  int MA;

  back_button(0);
  MA= message_area("Selected:");

  L= gfx_list(GFX_UPDATE,30,50,100,210, AC_LIST1);
  for(j=0;list1[j].str;j++)
    gfx_list_insert(L,-1,list1[j].str,NULL,
      icon_data[j%5],icon_width[j%5], icon_height[j%5]);

  button(0,"Delete", AC_LIST_DELETE);
  button(0,"Insert", AC_LIST_INSERT);
  button(0,"Clear", AC_LIST_CLEAR);

  int E1,E2;
  E1= gfx_text_entry(GFX_UPDATE, 130, 290, 150, 30, "");
  E2= gfx_text_entry(GFX_UPDATE, 130, 330, 150, 30, "");

  gfx_print(GFX_UPDATE,1, 0x00, SCR_BG, 30, 290, "Text", NULL,NULL);
  gfx_print(GFX_UPDATE,1, 0x00, SCR_BG, 30, 330, "Position", NULL,NULL);

  gfx_show(L,1);

again:
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_LIST1:
        meprintf(MA,"[%03d] %s", event.key,event.string);
        break;
     case AC_LIST_DELETE:
        i= gfx_list_selected(L);
        if (i!=-1)
           gfx_list_delete(L, i, 1);
        break;
     case AC_LIST_INSERT:
        j= atoi(gfx_text_entry_get(E2));
        gfx_list_insert(L, j, gfx_text_entry_get(E1), NULL, NULL,0,0);
        break;
     case AC_LIST_CLEAR:
        gfx_list_clear(L);
        break;
     }
}

static int demo(int (*func)())
{
  int OS;
  int R;
  but_x= PAD;
  but_y= PAD;
  last_msg= SCR_H;

  OS= gfx_push_screen();
  gfx_fill_rect(GFX_UPDATE,0,0,SCR_W,SCR_H,0xededed);
  R= (*func)();
  gfx_restore_screen(OS);
  return R;
}

static int demo_dropdown()
{
  gfx_event_t event;
  int DD;
  char buf[200];
  int i;
  int msg,msg2;
  char *s_str;
  void *s_ptr;

  back_button(1);
  
  DD= gfx_dropdown(50, 100, 100, 30, AC_DROPDOWN_1);
  for(i=0;i<50;i++)
  {
   sprintf(buf,"Choice %d", i);
   gfx_dropdown_insert(DD, -1, buf, strdup(buf));
  }
  gfx_dropdown_select(DD,5);
  gfx_show(DD,1);

  msg= message_area(NULL);
  msg2= message_area(NULL);

  int S;
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_DROPDOWN_1: 
          meprintf(msg,"selected item %d: %s", event.key, event.usr);
          S= gfx_dropdown_selected(DD);
          if (S!=-1)
          {
            gfx_dropdown_get(DD, S, &s_str, &s_ptr);
            meprintf(msg2, "thru _get(): %s: %s", s_str, s_ptr);
          }
          break;
     }
}

static int demo_radio()
{
  gfx_event_t event;
  char buf[200];
  int i;
  int msg,msg2;
  int radio[4];

  back_button(1);
  
  radio[0]= -1;
  for(i=0;i<4;i++)
  {
    sprintf(buf,"Radio %d", i+1);
    radio[i]= gfx_radio(50, i*30+50, 150, 30, buf, AC_RADIO1+i, i, radio[0]);
  }
  gfx_radio_set(radio[0]);
  for(i=0;i<4;i++)
    gfx_show(radio[i],1);

  msg= message_area("Get radio[0]: ");
  msg2= message_area("Event: ");

  int S;
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_RADIO1: 
     case AC_RADIO2: 
     case AC_RADIO3: 
     case AC_RADIO4: 
        meprintf(msg,"%d", gfx_radio_get(radio[0]));
        meprintf(msg2,"%d", event.type);
        break;
     }
}

static int demo_checkbox()
{
  gfx_event_t event;
  char buf[200];
  int i;
  int msg,msg2;
  int check[4];

  back_button(1);
  
  check[0]= -1;
  for(i=0;i<4;i++)
  {
    sprintf(buf,"Radio %d", i+1);
    check[i]= gfx_checkbox(50, i*30+50, 150, 30, buf, AC_CHECK1+i);
  }
  gfx_checkbox_set(check[0],1);
  for(i=0;i<4;i++)
    gfx_show(check[i],1);

  msg= message_area("Get check[0,1,2,3]: ");
  msg2= message_area("Event: ");

  int S;
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_CHECK1: 
     case AC_CHECK2: 
     case AC_CHECK3: 
     case AC_CHECK4: 
        meprintf(msg,"%d %d %d %d", 
             gfx_checkbox_get(check[0]),
             gfx_checkbox_get(check[1]),
             gfx_checkbox_get(check[2]),
             gfx_checkbox_get(check[3]));
        meprintf(msg2,"%d (%d)", event.type, event.key);
        break;
     }
}

static int demo_filesel()
{
  gfx_event_t event;
  int msg;
  char *R;

  back_button(1);
  button(0, "Start", AC_FILESEL_GO);
  
  msg= message_area("Result: ");

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_FILESEL_GO: 
        R= gfx_select_file(1, "/home/dodo/tmp/a.out",NULL);
        if (R) meprintf(msg, "%s",R);
          else meprintf(msg, "NULL");
        break;
     }
}

static int demo_togbut()
{
  gfx_event_t event;
  int msg;
  char *R;
  int tbf,tbv;
  int ent;
  int t1w,t1h,t2w,t2h;
  char *m1,*m2;

  int x,y,w,h;

  back_button(1);

  m1= "Fixed (80x30)";
  m2= "Variable (6x6 pad)"; 

  gfx_text_size(1, m1, &t1w,&t1h);
  gfx_text_size(1, m2, &t2w,&t2h);

  x= 50; y= 100;
  gfx_print(0, 1, 0x00, 0xededed, x,y+(30-t1h)/2, m1, NULL, NULL);

  x+= t2w + PAD;
  tbf= gfx_toggle_button(x, y, 80, 30, 0,0, "Fixed", AC_TOGBUT_1);
  gfx_show(tbf,1);

  x= 50; y+= 30 + PAD;

  gfx_print(0, 1, 0x00, 0xededed, x,y, m2, &w,&h);
  x+= t2w+ PAD;
  tbv= gfx_toggle_button(x,y, 0,0, 6,6, "Variable", AC_TOGBUT_2);
  gfx_show(tbv,1);

  x= 50; y+= (t1h+6) + PAD;

  ent= gfx_text_entry(GFX_FOCUS | GFX_UPDATE, x,y, 100, 30, "Text");
  x+= 100 + PAD;
  gfx_button(GFX_UPDATE,x,y, BUT_W_BIG, BUT_H, "Set Fixed", AC_TOGBUT_SET1);
  x+= BUT_W_BIG+PAD;
  gfx_button(GFX_UPDATE,x,y, BUT_W_BIG, BUT_H, "Set Variable", AC_TOGBUT_SET2);


  msg= message_area(NULL);
  gfx_update_all();

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_TOGBUT_1:
        meprintf(msg, "clicked 1 : %d",event.key);
        gfx_toggle_button_set(tbf, event.key ^1);
        break;
     case AC_TOGBUT_2:
        meprintf(msg, "clicked 2 : %d",event.key);
        gfx_toggle_button_set(tbv, event.key ^1);
        break;
     case AC_TOGBUT_SET1:
     case AC_TOGBUT_SET2:
        gfx_toggle_button_set_text(event.type==AC_TOGBUT_SET1?tbf:tbv, 
                               gfx_text_entry_get(ent));
        break;
     }
}

static int demo_confirm()
{
  gfx_event_t event;
  int msg;
  int k=0;

  back_button(1);
  button(1,"Show Dialog", AC_CONFIRM_1);
  button(1,"No Title", AC_CONFIRM_2);

  msg= message_area(NULL);
  gfx_update_all();

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_CONFIRM_1:
       meprintf(msg,"Dialog 1: %d", 
          gfx_ask("Question", "!OK!Cancel", "Do you really want to proceed,\n"
                                          "for the %d-th time?", ++k));
       break;
     case AC_CONFIRM_2:
       meprintf(msg,"Dialog 2: %d", 
          gfx_ask(NULL, "@OK@Cancel@Maybe", 
                   "Another dialog, look, no title!\n"
                   "\n"
                   "empty line and an argument: %04x?",
                    ++k));
       break;
     }
}

int main(int argc,char **argv)
{
  gfx_event_t event;
  
  if (gfx_init(NULL,SCR_W,SCR_H,"Widget Demo")) return 1;
  gfx_fill_rect(GFX_UPDATE,0,0,SCR_W,SCR_H,SCR_BG);

  button(1,"OSD Menu", AC_DEMO_MENU);
  button(1,"Scroll Bar", AC_DEMO_SCROLL);
  button(1,"List", AC_DEMO_LIST);
  button(1,"Dropdown", AC_DEMO_DROPDOWN);
  button(1,"Radio", AC_DEMO_RADIO);
  button(1,"CheckBox", AC_DEMO_CHECKBOX);
  button(1,"Select File", AC_DEMO_FILESEL);
  button(1,"Toggle Button", AC_DEMO_TOGBUT);
  button(1,"Confirmation", AC_DEMO_CONFIRM);

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case AC_DEMO_MENU: if (demo(demo_menus)) goto done; break;
     case AC_DEMO_SCROLL: if (demo(demo_scrollbar)) goto done; break;
     case AC_DEMO_LIST: if (demo(demo_list)) goto done; break;
     case AC_DEMO_DROPDOWN: if (demo(demo_dropdown)) goto done; break;
     case AC_DEMO_RADIO: if (demo(demo_radio)) goto done; break;
     case AC_DEMO_CHECKBOX: if (demo(demo_checkbox)) goto done; break;
     case AC_DEMO_FILESEL: if (demo(demo_filesel)) goto done; break;
     case AC_DEMO_TOGBUT: if (demo(demo_togbut)) goto done; break;
     case AC_DEMO_CONFIRM: if (demo(demo_confirm)) goto done; break;
     case GFXEV_QUIT: goto done;
     }

done:
  gfx_close();
  return 0;
}
